/*
  Как подключить:
    LCD:
      GND - GND
      VDD - 5V
      VO - GND
      RS - D12
      RW - GND
      Enable(E) - D11
      D4 - D5
      D5 - D4
      D6 - D3
      D7 - D2
      BLA - 5V
      BLK - GND
    Button:
      button1(1) - GND
      button1(2) - D10
      button2(1) - GND
      button2(2) - D9
  Прошивка версии: 5.5
*/

int timer = 120;
long int secud = 0;
int ol = 0;
int lo = 0;



// include the library code:
#include <LiquidCrystal.h>
int punt = 1;

// initialize the library by associating any needed LCD interface pin
// with the arduino pin number it is connected to
const int rs = 12, en = 11, d4 = 5, d5 = 4, d6 = 3, d7 = 2;
LiquidCrystal lcd(rs, en, d4, d5, d6, d7);

byte Var[] = {
  B00100,
  B01010,
  B10101,
  B10101,
  B10001,
  B10101,
  B10001,
  B11111
};

void setup() {
  // set up the LCD's number of columns and rows:
  lcd.begin(16, 2);
  Serial.begin(9600);
  pinMode(9, INPUT_PULLUP);
  pinMode(10, INPUT_PULLUP);
  // Print a message to the LCD.
  Serial.println("Загруска устройства");
  lcd.print("Hi!");
  lcd.setCursor(0, 1);
  lcd.print("by ChudoWindows");
  delay(3000);
  lcd.clear();
  lcd.print("Loading...");
  delay(5000);
  lcd.clear();
  lcd.print("Loading");
  lcd.setCursor(0, 1);
  lcd.print("Complect!");
  Serial.println("Загруска выполнена!");
  delay(1000);
  lcd.clear();
}

boolean flag = false;
boolean flag_timer = false;

void loop() {
  // set the cursor to column 0, line 1
  // (note: line 1 is the second row, since counting begins with 0):
  start();
  if (punt == 4 && flag == true) {
    if (Serial.available() > 0) {
      ol = Serial.parseInt();
      lcd.clear();
      lcd.print("Guess the number");
      lcd.setCursor(0, 1);
      lcd.print("Your number: ");
      lcd.print(ol);
      delay(3000);
      if (ol != lo) {
        lcd.clear();
        lcd.print("NO");
        delay(3000);
      } else {
        lcd.clear();
        lcd.print("YES");
        delay(3000);
      }
      flag = false;
      start();
    }
    lcd.print("Guess the number");
    lcd.setCursor(0, 1);
    lcd.print("Your number: ");

    delay(500);
    lcd.clear();
  }
  if (punt == 3 && flag == true) {
    if (!digitalRead(9) == true) {
      flag = false;
      secud = 0;
      delay(500);
    } else {
      if (secud > 9999) {
        flag = false;
        secud = 0;
        delay(500);
      } else {
        secud++;
        lcd.clear();
        lcd.print("Stopwatch: ");
        lcd.print(secud);
        delay(1000);
      }
    }
  }
  if (punt == 1 && flag == true) {
    timer--;
    if (timer == 0) {
      lcd.clear();
      lcd.setCursor(4, 0);
      lcd.print("Timer");
      lcd.setCursor(0, 1);
      lcd.print("Time's up");
      Serial.println("Время вышло");
      delay(3000);
      Serial.println("МЕНЮ");
      timer = 0;
      flag = false;
    } else {
      lcd.clear();
      lcd.print("Enter to");
      lcd.setCursor(0, 1);
      lcd.print("secunds timer");
      if (Serial.available() > 0) {
        timer = Serial.parseInt();
        if (timer == 10001) {
          lcd.clear();
          lcd.setCursor(4, 0);
          lcd.print("Fool");
          lcd.cursor();
          delay(500);
          lcd.noCursor();
          delay(500);
          Fool();
        } else if (timer > 10000) {
          flag = false;
          flag_timer = false;
          setup();
        } else {
          flag_timer = true;
          Serial.flush();
        }
      }
      if (flag_timer == true) {
        lcd.clear();
        lcd.print("TIMER: ");
        lcd.print(timer);
        delay(1000);
        lcd.clear();
      }

    }

  }
  if (!digitalRead(9) == true) {
    timer = 0;
    flag_timer = false;
    flag = true;
    lo = 0+6/2*2/2-1+random(11);
    if (lo >= 10) {
      Serial.println("ERROR");
      lcd.clear();
      lcd.setCursor(4, 0);
      lcd.print("EEROR");
      delay(3000);
      flag = false;
    }else if (lo == 0){
      Serial.println("ERROR");
      lcd.clear();
      lcd.setCursor(4, 0);
      lcd.print("EEROR");
      delay(3000);
      flag = false;
    }

    delay(500);
    if (punt == 2 && flag == true) {
      lcd.setCursor(2, 0);
      lcd.print("Dodge charg");
      lcd.setCursor(2, 1);
      lcd.print("Don't buy it!");
      lcd.setCursor(0, 1);
      lcd.print("!");
      lcd.setCursor(0, 0);
      lcd.print("!");
      lcd.setCursor(15, 1);
      lcd.print("!");
      lcd.setCursor(15, 0);
      lcd.print("!");
      Serial.println("Выбран тескт!");
      delay(10000);
      Serial.println("МЕНЮ");
      flag = false;
    }
  }
  if (!digitalRead(10) == true) {
    if (punt == 1) {
      punt = 2;
    } else if (punt == 2) {
      punt = 3;
    } else if (punt == 3) {
      punt = 4;
    } else if (punt == 4) {
      punt = 1;
    }
    delay(500);
  }
}

void start() {
  if (flag == false) {
    if (punt == 1) {
      lcd.print("-> Timer");
      lcd.setCursor(3, 3);
      lcd.print("Text");
      delay(500);
      lcd.clear();
    } if (punt == 2) {
      lcd.print("   Timer");
      lcd.setCursor(0, 1);
      lcd.print("-> Text");
      delay(500);
      lcd.clear();
    } if (punt == 3) {
      lcd.print("-> Stopwatch");
      lcd.setCursor(3, 1);
      lcd.print("Guess");
      delay(500);
      lcd.clear();
    } if (punt == 4) {
      lcd.setCursor(3, 0);
      lcd.print("Stopwatch");
      lcd.setCursor(0, 1);
      lcd.print("-> Guess");
      delay(500);
      lcd.clear();
    }
  }
}

void Fool() {
  lcd.clear();
  lcd.setCursor(2, 0);
  lcd.print("You're a FOOL");
  lcd.cursor();
  delay(500);
  lcd.noCursor();
  delay(500);
  Fool();
}
